/*
 * UPC Runtime common configuration template--parsed though autoconf 
 * to generate upcr_config.h.
 *  -- note: base file is 'acconfig.h'--make any changes there!
 *
 * Notes: 
 *  -- All public symbols should use UPCR_ ("UPC Runtime") prefix.
 *  -- All internal symbols should use UPCRI_ ("UPC Runtime internal") prefix.
 *	 -- Preprocessor symbols w/o this are autoconf-generated.
 *  -- We rely heavily on the GASNet config to avoid duplication.
 *
 * $Source: bitbucket.org:berkeleylab/upc-runtime.git/acconfig.h $
 */

#ifndef UPCR_CONFIG_H
#define UPCR_CONFIG_H

/* Everything above this is passed though autoconf verbatim */
@TOP@

#undef UPCR_VERSION
#undef UPCR_RUNTIME_SPEC_MAJOR
#undef UPCR_RUNTIME_SPEC_MINOR
#undef UPCRI_SYSTEM_NAME
#undef UPCRI_SYSTEM_TUPLE
#undef UPCRI_CONFIGURE_ARGS
#undef UPCRI_BUILD_ID

/* Whether this copy of the runtime is being used as a target for the gccupc
 * binary UPC compiler */
#undef UPCRI_USING_GCCUPC

/* Whether this copy of the runtime supports init sections generated by
 * the gccupc compilerm, or static copy must be done */
#undef UPCRI_USING_GCCUPC_INIT_SECTION
#undef UPCRI_USING_GCCUPC_INIT_STATIC_COPY

/* Whether this copy of the runtime is being used as a target for the
 * clang-upc2c source-to-source translator */
#undef UPCRI_USING_CUPC2C

/* Define if you wish to extend printf (and friends) with  %S/%P format 
 * specifiers for shared/pshared pointers (requires glibc) */
#undef UPCR_EXTEND_PRINTF

/* Whether or not to enable the GASP instrumentation hooks */
#undef UPCRI_GASP

/* Whether or not to enable the Thrille active testing hooks */
#undef UPCRI_THRILLE

/* Whether or not to use the libc malloc to manage the umalloc heap metadata */
#undef UMALLOC_EXTERNAL_METADATA

/* Whether or not to enable FCA support */
#undef UPCRI_FCA

/* Whether or not to use the more efficient 'packed' shared pointer representation */
#undef UPCRI_PACKED_SPTR

/* Whether or not to use the 'struct' shared pointer representation */
#undef UPCRI_STRUCT_SPTR

/* 'struct' shared pointer configuration information (when available) */
#undef UPCRI_STRUCT_SPTR_ADDR_TYPE
#undef UPCRI_STRUCT_SPTR_THREAD_TYPE
#undef UPCRI_STRUCT_SPTR_PHASE_TYPE
#undef UPCRI_STRUCT_SPTR_ADDR_FIELD
#undef UPCRI_STRUCT_SPTR_THREAD_FIELD
#undef UPCRI_STRUCT_SPTR_PHASE_FIELD
#undef UPCRI_STRUCT_SPTR_ALIGN

/* Set if the shoared pointer has the address field first */
#undef UPCRI_SPTR_ADDR_FIRST

/* Whether or not to enable the pshared symmetric pointer variant of shared pointers */
#undef UPCRI_SYMMETRIC_SPTR

/* configure-selected bit distribution for the packed shared pointer representation */
#undef UPCRI_PHASE_BITS_OVERRIDE
#undef UPCRI_THREAD_BITS_OVERRIDE
#undef UPCRI_ADDR_BITS_OVERRIDE

/* Whether to provide a 64-bit upc_off_t */
#undef BUPC_IO_64

/* have usable pthread_mutexattr_setpshared() */
#undef HAVE_PTHREAD_MUTEXATTR_SETPSHARED

/* have new linux pthreads library (NPTL) */
#undef HAVE_PTHREADS_NPTL

/* gcc built-ins */
#undef HAVE_BUILTIN_HUGE_VAL
#undef HAVE_BUILTIN_HUGE_VALF
#undef HAVE_BUILTIN_INF
#undef HAVE_BUILTIN_INFF
#undef HAVE_BUILTIN_NAN
#undef HAVE_BUILTIN_NANF

/* __thread attribute works for pthread-local data */
#undef HAVE_GCC_TLS_SUPPORT

/* supports __attribute((__aligned__(16))) */
#undef HAVE_GCC_ATTRIBUTE_ALIGNED

/* mcleanup() gprof function */
#undef HAVE_MCLEANUP

/* monitor_signal() Compaq profiling function */
#undef HAVE_MONITOR_SIGNAL

/* monitor(0) AIX profiling function */
#undef HAVE_MONITOR

/* monitor(0,0,0,0,0) Solaris profiling function */
#undef HAVE_MONITOR5

/* PGI rouexit profile cleanup function */
#undef HAVE_ROUEXIT

/* C program stack grows up */
#undef UPCRI_STACK_GROWS_UP

/* have attribute(cleanup) support */
#undef UPCRI_HAVE_ATTRIBUTE_CLEANUP

/* portable inttypes support */
#undef HAVE_INTTYPES_H
#undef HAVE_STDINT_H
#undef HAVE_SYS_TYPES_H
#undef COMPLETE_INTTYPES_H
#undef COMPLETE_STDINT_H
#undef COMPLETE_SYS_TYPES_H


/* Everything below this is passed though autoconf verbatim */
@BOTTOM@

/* Bug 1097: do NOT place any includes in this file - it should only contain definitions */

#endif /* UPCR_CONFIG_H */
